--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")
local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}

local _, ns = ...
local oUF = ns.oUF
local addonName, addon = ...
local function CreateBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(0,0,0,0.75)
	
end
local function CreateMoverBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0.55,0.95,0.45)
		frame:SetBackdropBorderColor(0,0,0,1)
end
local function HealthWrap(frame)
	local HealthWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		HealthWrapper:SetPoint("LEFT",frame,"LEFT",-3,0)
		HealthWrapper:SetSize(104,28)
		HealthWrapper:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 16,
		insets = {top = 4, left = 4, bottom = 4, right = 4}})
		HealthWrapper:SetBackdropColor(0,0,0,0)
		HealthWrapper:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
end
local function PowerWrap(frame)
	local PowerWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		PowerWrapper:SetPoint("LEFT",frame,"LEFT",-3,0)
		PowerWrapper:SetSize(104,21)
		PowerWrapper:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 16,
		insets = {top = 4, left = 4, bottom = 4, right = 4}})
		PowerWrapper:SetBackdropColor(0,0,0,0)
		PowerWrapper:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
end
local function CastBarWrap(frame)
	local CastBarWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		CastBarWrapper:SetPoint("LEFT",frame,"LEFT",-2,0)
		CastBarWrapper:SetSize(145,16)
		CastBarWrapper:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 10,
		insets = {top = 4, left = 4, bottom = 4, right = 4}})
		CastBarWrapper:SetBackdropColor(InkedColors.r,InkedColors.g,InkedColors.b,0)
		CastBarWrapper:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
end
local function AltPowerWrap(frame)
	local AltPowerWrap = CreateFrame("Frame","AltPowerWrap",frame, BackdropTemplateMixin and "BackdropTemplate")
		AltPowerWrap:SetPoint("LEFT",frame,"LEFT",-2,0)
		AltPowerWrap:SetSize(128,23)
		--AltPowerWrap:SetAllPoints(frame)
		AltPowerWrap:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 10,
		insets = {top = 4, left = 4, bottom = 4, right = 4}})
		AltPowerWrap:SetBackdropColor(InkedColors.r,InkedColors.g,InkedColors.b,0)
		AltPowerWrap:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
end
local function CastBarBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8"})
		frame:SetBackdropColor(0,0,0,1)
		frame:SetBackdropBorderColor(0,0,0,0)
end
local function HealthBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8"})
		frame:SetBackdropColor(0.3,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,0)
end
local function PowerBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8"})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,0)
end
local function RuneBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 8,
		insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(1,1,1,0)
end
local function PortraitWrap(frame)
	local PortraitWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		PortraitWrapper:SetFrameLevel(1)
		PortraitWrapper:SetPoint("LEFT",frame,"LEFT",-5,0)
		PortraitWrapper:SetSize(51,52)
		PortraitWrapper:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 16,
		insets = {top = 4, left = 4, bottom = 4, right = 4}})
		PortraitWrapper:SetBackdropColor(0,0,0,1)
		PortraitWrapper:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
end
local function CreateBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8"})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,0)
end

local PetMover = CreateFrame("Frame","PetDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	PetMover:SetSize(132,55)
	PetMover:SetPoint("CENTER",UIParent,"CENTER",-535,75)
	
	PetMover:SetClampedToScreen(true)
	PetMover:SetClampRectInsets(0, 0, 0,0)
	
local PetMoverText  = PetMover:CreateFontString(nil, "OVERLAY")
	PetMoverText:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.ttf", 16, "OUTLINE")
	PetMoverText:SetPoint("CENTER",PetMover,"CENTER", 0,0); 
	PetMoverText:SetText("")
	
	local function UpdateMe()
	if(Inked.db.profile.lockframes == false) then
		if Inked.db.profile.FocusFrameEnable == true then 
				Inked.db.profile.PetX = 0
				Inked.db.profile.PetY = 0
				local point, relativeTo, relativePoint, xOfs, yOfs = PetMover:GetPoint(n)
				Inked.db.profile.PetX = xOfs
				Inked.db.profile.PetY = yOfs
				Inked.db.profile.PetPoint = point
				PetMover:SetMovable(true)
				PetMover:EnableMouse(true)
				PetMover:RegisterForDrag("LeftButton")
				PetMover:SetScript("OnDragStart", PetMover.StartMoving)
				PetMover:SetScript("OnDragStop", PetMover.StopMovingOrSizing)
				PetMover:SetUserPlaced(true)
				PetMoverText:SetText("Pet Frame")
				CreateMoverBackdrop(PetMover)
			end
		end	
end	
	---Update Database check
	local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe)

local UnitSpecific = {

	pet = function(self)
		-- pet specific stuff
		---------------------------
		--  Player Pet Set Up  --
		---------------------------
		local PetWidth = 95;
		local PetHeight = 35;
		self:SetSize(PetWidth,PetHeight)
		--self:SetSize(145,40)

		------------------------
		--  Player Pet Level  --
		------------------------
		if Inked.db.profile.PetShowLevel == true then
		local LevelText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		LevelText:SetPoint("TOPLEFT", self, -45,21) -- but anchor to the base element so it doesn't wiggle
		LevelText:SetFont(LSM:Fetch("font", Inked.db.profile.PetLevelfont), Inked.db.profile.PetLevelFontSize, Inked.db.profile.PetLevelOutline)
		self:Tag(LevelText, "[level]") -- oUF will automagically update it!
		end
		---------------------------
		--  Player Pet Name  --
		---------------------------
		if Inked.db.profile.PetShowName == true then
			local NameText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
			NameText:SetPoint("TOPLEFT", self, 0,21) -- but anchor to the base element so it doesn't wiggle
			NameText:SetJustifyH("LEFT")
			NameText:SetFont(LSM:Fetch("font", Inked.db.profile.PetNamefont), Inked.db.profile.PetNameFontSize, Inked.db.profile.PetNameOutline)
			NameText:SetWidth(300)
			self:Tag(NameText, "[name]") -- oUF will automagically update it!
		end
		-------------------------------
		--  Player Pet Power Values  --
		-------------------------------
		

		local PowerText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		if Inked.db.profile.PetShowPowerPercent == true then
			PowerText:SetPoint("CENTER", self, 0,-15)
		elseif Inked.db.profile.PetShowBothPowerNumberandPercent == true then
			PowerText:SetPoint("RIGHT", self, -5,-15)
		end		
		PowerText:SetFont(LSM:Fetch("font", Inked.db.profile.PetPowerfont), Inked.db.profile.PetPowerFontSize, Inked.db.profile.PetPowerOutline)
		self:Tag(PowerText, "[perpp]".." %") -- oUF will automagically update it!

		local PowerText2 = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		if Inked.db.profile.PetShowPowerNumbers == true then
			PowerText2:SetPoint("CENTER", self, 0,-15)
		elseif Inked.db.profile.PetShowBothPowerNumberandPercent == true then
			PowerText2:SetPoint("LEFT", self, 5,-15)
		end	
		PowerText2:SetFont(LSM:Fetch("font", Inked.db.profile.PetPowerfont), Inked.db.profile.PetPowerFontSize, Inked.db.profile.PetPowerOutline)
		self:Tag(PowerText2, "[curpp]") -- oUF will automagically update it!

		--------------------------------
		--  Player Pet Health Values  --
		--------------------------------
		

		local HealthText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		if Inked.db.profile.PetShowHealthPercent == true then
			HealthText:SetPoint("CENTER", self, 0,7)
		elseif Inked.db.profile.PetShowBothNumberandPercent == true then
			HealthText:SetPoint("RIGHT", self,-5,7)
		end	
		HealthText:SetFont(LSM:Fetch("font", Inked.db.profile.PetHealthfont), Inked.db.profile.PetHealthFontSize, Inked.db.profile.PetHealthOutline)
		self:Tag(HealthText, "[perhp]".." %") -- oUF will automagically update it!

		local HealthText2 = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		if Inked.db.profile.PetShowHealthNumbers == true then
			HealthText2:SetPoint("CENTER", self, 0,7)
		elseif Inked.db.profile.PetShowBothNumberandPercent == true then
			HealthText2:SetPoint("LEFT", self, 5,7)
		end		
		HealthText2:SetFont(LSM:Fetch("font", Inked.db.profile.PetHealthfont), Inked.db.profile.PetHealthFontSize, Inked.db.profile.PetHealthOutline)
		self:Tag(HealthText2, "[Inked:MyHealth]") -- oUF will automagically update it!

		---------------------------
		--  Player Pet Portrait  --
		---------------------------

		self.Portrait:SetPoint('CENTER', self, 'LEFT', -25,-3)
		self.Portrait:SetSize(40, 41)

		-----------------------------------------------
		--  Player Pet Health and Power Adjustments  --
		-----------------------------------------------

		self.Health:SetHeight(21)
		self.Power:SetHeight(15)


		------------------------------------------------------
		--  Player Pet Cast Bar (Not Availible in Classic)  --
		------------------------------------------------------
		if Inked.db.profile.PetCastBar == true then
			self.Castbar:SetPoint('CENTER', self.Power, -22, -20)
			self.Castbar:SetSize(140, 10)
		end
		------------------------
		--  Player Pet Auras  --
		------------------------
		if Inked.db.profile.PetAuras == true then
			local Auras = CreateFrame("Frame", nil, self, BackdropTemplateMixin and "BackdropTemplate")
			Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0,25)
			Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 0, 25)
			Auras:SetHeight(20)
			Auras:SetHeight(20 + 4)

			Auras.size = 20
			Auras.onlyShowPlayer = false
			Auras.gap = 5
			Auras.spacing = 4
			Auras.showStealableAuras = true
			Auras.disableCooldown = false
			Auras.num = 16

			Auras.PostCreateIcon = Aura_PostCreateIcon
			self.Auras = Auras
		end


	end,-- End Pet
	

}
	

local Shared = function(self, unit)
	-- Shared layout code.
	self:SetScale(Inked.db.profile.PetScale)
	-----------------
	--  Mouse Code --
	-----------------
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	self:RegisterForClicks'AnyUp'
	------------------
	--  Health Bars --
	------------------

	local Health = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
	Health:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.PetHealthStatusBar))
	Health:SetPoint('TOP')
	Health:SetPoint('LEFT')
	Health:SetPoint('RIGHT')
	Health:SetFrameLevel(2)
	HealthWrap(Health)
	CreateBackdrop(Health)

	-- Options
	--Health.frequentUpdates = true
	Health.colorTapping = true
	Health.colorDisconnected = true
	Health.colorClass = true
	Health.colorReaction = true
	Health.colorHealth = true
	-- Register it with oUF
	self.Health = Health
	self.Health.bg = Healthbg

    -----------------
	--  Power Bars --
	-----------------

	local Power = CreateFrame("StatusBar", nil, Health, BackdropTemplateMixin and "BackdropTemplate")
	Power:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.PetPowerStatusBar))
	Power:SetPoint('BOTTOM',Health,'BOTTOM',0,-20)
	Power:SetPoint('LEFT')
	Power:SetPoint('RIGHT')
	Power:SetFrameLevel(1)
	PowerWrap(Power)
	CreateBackdrop(Power)
	

	-- Options
	--Power.frequentUpdates = true
	Power.colorPower = true -- powertype colored bar
	Power.colorClassNPC = false -- color power based on NPC
	Power.colorClassPet = false -- color power based on pet type
	-- Register it with oUF
	self.Power = Power
	self.Power.bg = Powerbg

	------------------
	--   Portrait --
	------------------
	-- 3D Portrait
	local Portrait = CreateFrame('PlayerModel', nil, self, BackdropTemplateMixin and "BackdropTemplate")
	PortraitWrap(Portrait)
	-- Register it with oUF
	self.Portrait = Portrait

	--------------
	-- Cast Bar --
	--------------
	if Inked.db.profile.PetCastBar == true then
	-- Position and size
		local Castbar = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
		Castbar:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.PetCastBarStatusBar))
		Castbar:SetStatusBarColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
		CastBarWrap(Castbar)
		

		-- Add a background
		CreateBackdrop(Castbar)
		-- Add a spark
		local Spark = Castbar:CreateTexture(nil, "OVERLAY")
		Spark:SetSize(65, 8)
		Spark:SetBlendMode("ADD")

		-- Add a timer
		local Time = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
		Time:SetFont(LSM:Fetch("font", Inked.db.profile.PetCastBarfont), Inked.db.profile.PetCastBarFontSize, Inked.db.profile.PetCastBarOutline)
		Time:SetTextColor(0.95, 0.95, 0.95)
		Time:SetPoint("RIGHT", Castbar, -3, 1)

		-- Add spell text
		local Text = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
		Text:SetFont(LSM:Fetch("font", Inked.db.profile.PetCastBarfont), Inked.db.profile.PetCastBarFontSize, Inked.db.profile.PetCastBarOutline)
		Text:SetTextColor(0.95, 0.95, 0.95)
		Text:SetPoint("LEFT", Castbar, 3, 1)

		-- Add Shield
		local Shield = Castbar:CreateTexture(nil, "OVERLAY")
		Shield:SetSize(25, 15)
		Shield:SetPoint("CENTER", Castbar)

		local Icon = Castbar:CreateTexture(nil, 'OVERLAY')
		Icon:SetSize(16, 16)
		Icon:SetPoint('LEFT', Castbar, 'LEFT',-20,0)
		-- Add safezone
		local SafeZone = Castbar:CreateTexture(nil, "OVERLAY")

		-- Register it with oUF
		self.Castbar = Castbar
		self.Castbar.bg = Background
		self.Castbar.Spark = Spark
		self.Castbar.Time = Time
		self.Castbar.Text = Text
		self.Castbar.SafeZone = SafeZone
		self.Castbar.Icon = Icon
	end
	-----------------
	-- Smooth Bars --
	-----------------

	self.Health.Smooth = true
		if self.Power then
			self.Power.Smooth = true
		end



	if(UnitSpecific[unit]) then
		return UnitSpecific[unit](self)
	end
end

oUF:RegisterStyle("InkedPet", Shared)
oUF:Factory(function(self)

	-----------------
	-- Unit Set Up --
	-----------------
     self:SetActiveStyle("InkedPet")

	--  self:Spawn("pet"):SetPoint("CENTER",UIParent,-390,-360)
	  if Inked.db.profile.PetPoint == nil then
		 self:Spawn("pet"):SetPoint("Center",UIParent,Inked.db.profile.PetX,Inked.db.profile.PetY)
		PetMover:SetPoint("Center",UIParent,Inked.db.profile.PetX,Inked.db.profile.PetY)
	  else
		 self:Spawn("pet"):SetPoint(Inked.db.profile.PetPoint,UIParent,Inked.db.profile.PetX,Inked.db.profile.PetY)
		PetMover:SetPoint(Inked.db.profile.PetPoint,UIParent,Inked.db.profile.PetX,Inked.db.profile.PetY)
	  end


end)
